package com.loafle.overflow.commons.model;

import java.util.ArrayList;
import java.util.List;

public class PublishMessage {
    private List<String> targets;
    private PublishMessageBody message;

    public void setTargets(List<String> targets) {
        this.targets = targets;
    }

    public void addTarget(String target) {
        if (null == targets) {
            targets = new ArrayList<>();
        }
        targets.add(target);
    }

    public List<String> getTargets() {
        return targets;
    }

    public void setMessage(PublishMessageBody message) {
        this.message = message;
    }

    public PublishMessageBody getMessage() {
        return message;
    }

    public static class PublishMessageBody {
        private String method;
        private List<String> params;

        public PublishMessageBody() {

        }
        public PublishMessageBody(String method) {
            this.method = method;
        }
        public PublishMessageBody(String method, List<String> params) {
            this(method);
            this.params = params;
        }

        public String getMethod() {
            return method;
        }

        public void setMethod(String method) {
            this.method = method;
        }

        public List<String> getParams() {
            return params;
        }

        public void setParams(List<String> params) {
            this.params = params;
        }

        public void addParams(String param) {
            if (null == this.params) {
                this.params = new ArrayList<>();
            }
            this.params.add(param);
        }
    }
}
